from re import sub, findall, search
from hashlib import shake_256


def wash_paragraph(text):
    text = sub('\s+', ' ', text)
    text = sub('^[ 0-9.,:#)(。，：、]+', '', text)
    text = sub(' +$', '', text)
    return text

def compact_hash(text, size=32):
    text = sub('[^\u4e00-\u9fa5\da-zA-Z]', '', text)
    hash = shake_256(text.encode('utf8')).hexdigest(int(size/2))
    return hash

def compact_mark(text, size=32):
    text = sub('[^\u4e00-\u9fa5\da-zA-Z]', '', text)
    if len(text) > size:
        text = shake_256(text.encode('utf8')).hexdigest(int(size/2))
    return text

def sound_len(text):
    return len(findall('[\u4e00-\u9fa5\da-zA-Z]', text))


class chre():
    
    def __init__(self, s):
        self.s = s
        
    def sub(self, *vs, **kvs):
        s = sub(*vs, string=self.s, **kvs)
        return chre(s)

    def search(self, *vs, **kvs):
        s = search(*vs, string=self.s, **kvs).group(0)
        return chre(s)
    
    def replace(self, *vs, **kvs):
        s = self.s.replace(*vs, **kvs)
        return chre(s)

    def wash_paragraph(self):
        s = wash_paragraph(self.s)
        return chre(s)
